#include <stdio.h>
#include <stdlib.h>

void ucitaj(int n, int m,  int a[][10000000])
{
    int i,j;
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=m; j++)
        {
            scanf("%d", &a[i][j]);
        }
    }
}

void pisi(int n, int m,  int a[][10000000])
{
    int i,j;
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=m; j++)
        {
            printf("%d ",a[i][j]);
        }
        printf("\n");
    }
}

void ucitaj2(int n, int m,  int a[][2])
{
    int i,j;
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=m; j++)
        {
            scanf("%d", &a[i][j]);
        }
    }
}

void pisi2(int n, int m,  int a[][2])
{
    int i,j;
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=m; j++)
        {
            printf("%d ",a[i][j]);
        }
        printf("\n");
    }
}

int main()
{
    int n,m,q,p=2,i,j,s=0,promena,c,b;
    static int a[10000000][10000000];
    static int u[10000000][2];
    scanf("%d%d", &n, &m);
    ucitaj(n,m,a);
    scanf("%d", &q);
    ucitaj2(q,p,u);
    int minimum_odredjen,preskoci_minimum,min1;
    preskoci_minimum=0;
    minimum_odredjen=0;
    min1=0;
    for(int z=1; z<=q; z++)
    {
        preskoci_minimum=0;
        minimum_odredjen=0;
        min1=0;
        for(c=m; c>=1; c--)
        {
            s=0;
            i=1;
            j=1;
            preskoci_minimum=0;

            for(b=1; b<=m+1; b++)
            {
                promena = c;
                if(i==u[z][1] && j==u[z][2])
                {
                    preskoci_minimum=1;
                }
                s+=a[i][j];
                if(j<promena)
                {
                    j++;
                }
                else if(j==promena && i==1)
                {
                    i++;
                }
                else
                {
                    j++;
                }
            }
            if(preskoci_minimum==0 && min1==0)
            {
                min1=s;
            }
            else if(s<min1)
            {
                min1=s;
            }
        }
        printf("%d\n", min1);
    }
    return 0;
}